package MT::Plugin::colorEditor;

use strict;

use base qw( MT::Plugin );

my $plugin = new MT::Plugin ({
	name => 'colorEditor',
	version => '1.01',
	doc_link => 'http://blog.webcreativepark.net/2008/04/30-234954.html',
	author_name => 'Kazuma Nishihata',
	author_link => 'http://www.to-r.net',
	description => 'MT4.1のエントリーの入力画面に色選択ボタンを付ける'
});
MT->add_plugin ($plugin);

MT->add_callback('MT::App::CMS::template_source.archetype_editor', 9, $plugin, \&_app_template_source_asset_insert);

sub _app_template_source_asset_insert {
	my ($eh, $app, $tmpl_ref) = @_;
	my $old = <<HTML;
<!-- a href="javascript: void 0;" title="<__trans phrase="Text Color" escape="html">" class="command-color toolbar button"><b>Text Color</b><s></s></a -->
HTML
	$old = quotemeta($old);
	my $new= <<HTML;
	<style type="text/css">
#pick{
	position:relative;
}
#colorPicker{
		position:absolute;
}
#colorPicker a{
		display:block;
		width:11px;
		height:11px;
		float:left;
		border-left :1px solid #FFF;
		border-bottom :1px solid #FFF;
}
	</style>
	<script type="text/javascript">
function showColorPicker(){
	if(!document.getElementById("colorPicker")){
		var colors = new Array('#000000','#000000','#003300','#006600','#009900','#00CC00','#00FF00','#330000','#333300','#336600','#339900','#33CC00','#33FF00','#660000','#663300','#666600','#669900','#66CC00','#66FF00',
'#333333','#000033','#003333','#006633','#009933','#00CC33','#00FF33','#330033','#333333','#336633','#339933','#33CC33','#33FF33','#660033','#663333','#666633','#669933','#66CC33','#66FF33',
'#666666','#000066','#003366','#006666','#009966','#00CC66','#00FF66','#330066','#333366','#336666','#339966','#33CC66','#33FF66','#660066','#663366','#666666','#669966','#66CC66','#66FF66',
'#999999','#000099','#003399','#006699','#009999','#00CC99','#00FF99','#330099','#333399','#336699','#339999','#33CC99','#33FF99','#660099','#663399','#666699','#669999','#66CC99','#66FF99',
'#CCCCCC','#0000CC','#0033CC','#0066CC','#0099CC','#00CCCC','#00FFCC','#3300CC','#3333CC','#3366CC','#3399CC','#33CCCC','#33FFCC','#6600CC','#6633CC','#6666CC','#6699CC','#66CCCC','#66FFCC',
'#FFFFFF','#0000FF','#0033FF','#0066FF','#0099FF','#00CCFF','#00FFFF','#3300FF','#3333FF','#3366FF','#3399FF','#33CCFF','#33FFFF','#6600FF','#6633FF','#6666FF','#6699FF','#66CCFF','#66FFFF',
'#FF0000','#990000','#993300','#996600','#999900','#99CC00','#99FF00','#CC0000','#CC3300','#CC6600','#CC9900','#CCCC00','#CCFF00','#FF0000','#FF3300','#FF6600','#FF9900','#FFCC00','#FFFF00',
'#00FF00','#990033','#993333','#996633','#999933','#99CC33','#99FF33','#CC0033','#CC3333','#CC6633','#CC9933','#CCCC33','#CCFF33','#FF0033','#FF3333','#FF6633','#FF9933','#FFCC33','#FFFF33',
'#0000FF','#990066','#993366','#996666','#999966','#99CC66','#99FF66','#CC0066','#CC3366','#CC6666','#CC9966','#CCCC66','#CCFF66','#FF0066','#FF3366','#FF6666','#FF9966','#FFCC66','#FFFF66',
'#FFFF00','#990099','#993399','#996699','#999999','#99CC99','#99FF99','#CC0099','#CC3399','#CC6699','#CC9999','#CCCC99','#CCFF99','#FF0099','#FF3399','#FF6699','#FF9999','#FFCC99','#FFFF99',
'#FF00FF','#9900CC','#9933CC','#9966CC','#9999CC','#99CCCC','#99FFCC','#CC00CC','#CC33CC','#CC66CC','#CC99CC','#CCCCCC','#CCFFCC','#FF00CC','#FF33CC','#FF66CC','#FF99CC','#FFCCCC','#FFFFCC',
'#00FFFF','#9900FF','#9933FF','#9966FF','#9999FF','#99CCFF','#99FFFF','#CC00FF','#CC33FF','#CC66FF','#CC99FF','#CCCCFF','#CCFFFF','#FF00FF','#FF33FF','#FF66FF','#FF99FF','#FFCCFF','#FFFFFF'
	 );

		var div = document.createElement("div");
		div.style.width="230px"
		div.id = "colorPicker";
		for(var i=0 ; i<colors.length ; i++){
			var a = document.createElement("a");
			a.href="#"
			a.onclick = chooseColor;
			a.setAttribute('rgbColor',colors[i]);
			a.style.backgroundColor=colors[i];
			div.appendChild(a);
		}
		document.getElementsByTagName("body")[0].appendChild(div);
		var pb = document.getElementById("picker_button");
		div.style.top=(GetTopPos(pb)+20)+"px";
		div.style.left = GetLeftPos(pb) + 'px';
	}else{
		if(document.getElementById("colorPicker").style.display=="none"){
			document.getElementById("colorPicker").style.display="block"
			var pb = document.getElementById("picker_button");
			document.getElementById("colorPicker").style.top=(GetTopPos(pb)+20)+"px";
			document.getElementById("colorPicker").style.left=GetLeftPos(pb) + 'px';
		}else{
			document.getElementById("colorPicker").style.display="none"
		}
	}
}
function chooseColor(){

		var edit = app.editor.actual;
		if(app.editor.mode != 'iframe') {
			var text = edit.getSelectedText();
			if ( !defined(text) ) text = '';
			edit.setSelection( '<span style="color:'+this.getAttribute('rgbColor')+'">' + text + '</span>' );
		}else{
		
			var selection = edit.getSelection();
			
			if(selection.createRange) {
				range = selection.createRange();
				text = range.htmlText;
			}else if(selection.getRangeAt) {
				range = selection.getRangeAt(0);
				var df = range.cloneContents();
				var doc = range.startContainer.ownerDocument;
				var div = doc.createElement('div');
				div.appendChild(df);
				text = div.innerHTML;
			}
			
			var Newtext = '<span style="color:'+this.getAttribute('rgbColor')+'">' + text + '</span>';
			
			if(selection.createRange) {
				range.pasteHTML(Newtext);
			}else if(selection.getRangeAt) {
				edit.document.execCommand('inserthtml', false, Newtext); 
			}
			
		}
		document.getElementById("colorPicker").style.display='none';
		
	return false;
}

function GetLeftPos(Obj){
	var returnValue = Obj.offsetLeft;
	while((Obj = Obj.offsetParent) != null)returnValue += Obj.offsetLeft;
	return returnValue;
}
function GetTopPos(Obj){
	var returnValue = Obj.offsetTop;
	while((Obj = Obj.offsetParent) != null){
		returnValue += Obj.offsetTop;
	}
	return returnValue;
}
	</script>
<a href="javascript: void 0;" title="<__trans phrase="Text Color" escape="html">" class="toolbar button" onclick="showColorPicker()" style="background-position:-132px 0pt;margin-right:10px;" id="picker_button"><b>Text Color</b><s></s></a>
HTML
	$$tmpl_ref =~ s/$old/$new/;
	
}

1;